#ifndef POEFILTER_H_
#define POEFILTER_H_

#include <map>
#include <string>
#include <msp/core/application.h>
#include <msp/strings/regex.h>
#include "theme.h"

class Category;
class Filter;

class PoeFilter: public Msp::RegisteredApplication<PoeFilter>
{
public:
	class Loader: public Msp::DataFile::ObjectLoader<PoeFilter>
	{
	public:
		Loader(PoeFilter &);

	private:
		void category(const std::string &);
		void filter(const std::string &);
		void theme();
	};

private:
	std::string filename;
	Theme theme;
	std::map<std::string, Category> categories;
	std::map<std::string, Filter> filters;

public:
	PoeFilter(int, char **);

	virtual int main();

	const Theme &get_theme() const { return theme; }
	const Category &get_category(const std::string &) const;
	void find_categories(const Msp::Regex &, std::list<const Category *> &) const;
	const Filter &get_filter(const std::string &) const;
};

#endif
