#include <msp/strings/format.h>
#include "rarity.h"

using namespace std;
using namespace Msp;

void operator>>(const LexicalConverter &conv, Rarity &rarity)
{
	const string &str = conv.get();
	if(str=="Normal")
		rarity = NORMAL;
	else if(str=="Magic")
		rarity = MAGIC;
	else if(str=="Rare")
		rarity = RARE;
	else if(str=="Unique")
		rarity = UNIQUE;
	else
		throw lexical_error(format("Conversion of %s to Rarity", str));
}

void operator<<(LexicalConverter &conv, Rarity rarity)
{
	switch(rarity)
	{
	case NORMAL: conv.result("Normal"); return;
	case MAGIC: conv.result("Magic"); return;
	case RARE: conv.result("Rare"); return;
	case UNIQUE: conv.result("Unique"); return;
	default: conv.result(format("Rarity(%d)", static_cast<int>(rarity))); return;
	}
}
